C++异常捕捉与处理的深入讲解

前言

在阅读别人开发的项目中,也许你会经常看到了多处使用异常的代码,也许你也很少遇见使用异常处理的代码。那在什么时候该使用异常,又在什么时候不该使用异常呢?在学习完异常基本概念和语法之后,后面会有讲解。

(1)异常抛出和捕捉语句

//1.抛出异常
throw 异常对象
 
//2.异常捕捉
try{
 可能会发生异常的代码
}catch(异常对象){
 异常处理代码
}
  • throw子句:throw 子句用于抛出异常,被抛出的异常可以是C++的内置类型(例如: throw int(1);),也可以是自定义类型。
  • try区段:这个区段中包含了可能发生异常的代码,在发生了异常之后,需要通过throw抛出。
  • catch子句:每个catch子句都代表着一种异常的处理。catch子句用于处理特定类型的异常。catch块的参数推荐采用地址传递而不是值传递,不仅可以提高效率,还可以利用对象的多态性。

(2)异常的处理规则

  • throw抛出的异常类型与catch抓取的异常类型要一致;
  • throw抛出的异常类型可以是子类对象,catch可以是父类对象;
  • catch块的参数推荐采用地址传递而不是值传递,不仅可以提高效率,还可以利用对象的多态性。另外,派生类的异常捕获要放到父类异常扑获的前面,否则,派生类的异常无法被扑获;
  • 如果使用catch参数中,使用基类捕获派生类对象,一定要使用传递引用的方式,例如catch (exception &e);
  • 异常是通过抛出对象而引发的,该对象的类型决定了应该激活哪个处理代码;
  • 被选中的处理代码是调用链中与该对象类型匹配且离抛出异常位置最近的那一个;
  • 在try的语句块内声明的变量在外部是不可以访问的,即使是在catch子句内也不可以访问;
  • 栈展开会沿着嵌套函数的调用链不断查找,直到找到了已抛出的异常匹配的catch子句。如果抛出的异常一直没有函数捕获(catch),则会一直上传到c++运行系统那里,导致整个程序的终止。

(3)实例

实例1:抛出自定义类型异常。

class Data
{
public:
 Data() {}
};
 
void fun(int n)
{
 if(n==0)
  throw 0;//抛异常 int异常
 if(n==1)
  throw "error"; //抛字符串异常
 if(n==2)
 {
  Data data;
  throw data;
 }
 if(n>3)
 {
  throw 1.0;
 }
}
 
int main()
{
 try {
  fun(6);//当异常发生fun里面,fun以下代码就不会再执行,调到catch处执行异常处理代码,后继续执行catch以外的代码。当throw抛出异常后,没有catch捕捉,则整个程序会退出,不会执行整个程序的以下代码
  cout<<"*************"<<endl;
 }catch (int i) {
  cout<<i<<endl;
 }catch (const char *ptr)
 {
  cout<<ptr<<endl;
 }catch(Data &d)
 {
  cout<<"data"<<endl;
 }catch(...)//抓取 前面异常以外的所有其他异常
 {
  cout<<"all"<<endl;
 }
 return 0;
}

实例2:标准出错类抛出和捕捉异常。

#include <iostream>
using namespace std;
 
int main()
{
 try {
  char* p = new char[0x7fffffff]; //抛出异常
 }
 catch (exception &e){
  cout << e.what() << endl; //捕获异常,然后程序结束
 }
 return 0;
}

输出结果:

当使用new进行开空间时,申请内存失败,系统就会抛出异常,不用用户自定义异常类型,此时捕获到异常时,就可告诉使用者是哪里的错误,便于修改。

实例3:继承标准出错类的派生类的异常抛出和捕捉。

#include <iostream>
#include <exception>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
using namespace std;
class FileException :public exception
{
public:
 FileException(string msg) {
  this->exStr = msg;
 }
 virtual const char*what() const noexcept//声明这个函数不能再抛异常
 {
   return this->exStr.c_str();
 }
protected:
 string exStr;
};
 
void fun()
{
 int fd = ::open("./open.txt",O_RDWR);
 
 if(fd<0)
 {
  FileException openFail("open fail"); //创建异常对象
  throw openFail;//抛异常
 }
}
 
int main( )
{
 try {
  fun();
 } catch (exception &e) {//一般需要使用引用
  cout<<e.what()<<endl;
 }
 cout<<"end"<<endl;
 return 0;
}

当文件不存在时,输出结果:

如果在Linux上运行,上述代码需要根据环境修改:

98标准写法

~FileException()throw(){}//必须要
virtual const char*what() const throw()//声明这个函数不能再抛异常
{
  return this->exStr.c_str();
 }
 //编译
g++ main.cpp 

2011标准写法

~FileException()noexcept{}//必须要
virtual const char*what() const noexcept//声明这个函数不能再抛异常
{
  return this->exStr.c_str();
}
 //编译
g++ main.cpp -std=c++11 指定用c++11标准编译

(4)总结

1. 使用异常处理的优点:

传统错误处理技术,检查到一个错误,只会返回退出码或者终止程序等等,我们只知道有错误,但不能更清楚知道是哪种错误。使用异常,把错误和处理分开来,由库函数抛出异常,由调用者捕获这个异常,调用者就可以知道程序函数库调用出现的错误是什么错误,并去处理,而是否终止程序就把握在调用者手里了。
2. 使用异常的缺点:

如果使用异常,光凭查看代码是很难评估程序的控制流:函数返回点可能在你意料之外,这就导致了代码管理和调试的困难。启动异常使得生成的二进制文件体积变大,延长了编译时间,还可能会增加地址空间的压力。
C++没有垃圾回收机制,资源需要自己管理。有了异常非常容易导致内存泄漏、死锁等异常安全问题。 这个需要使用RAII来处理资源的管理问题。学习成本较高。
C++标准库的异常体系定义得不好,导致大家各自定义各自的异常体系,非常的混乱。
3. 什么时候使用异常?

建议:除非已有的项目或底层库中使用了异常,要不然尽量不要使用异常,虽然提供了方便,但是开销也大。
4. 程序所有的异常都可以catch到吗?

并非如此,只有发生异常,并且又抛出异常的情况才能被catch到。例如,数组下标访问越界的情况,系统是不会自身抛出异常的,所以我们无论怎么catch都是无效的;在这种情况,我们需要自定义抛出类型,判断数组下标是否越界,然后再根据自身需要throw自定义异常对象,这样才可以catch到异常,并进行进一步处理。

到此这篇关于C++异常捕捉与处理的文章就介绍到这了,更多相关C++异常捕捉与处理内容请搜索云海天教程以前的文章或继续浏览下面的相关文章希望大家以后多多支持云海天教程!

原文链接:https://www.cnblogs.com/lcgbk/p/13858425.html